﻿using GHI.Processor;
using Microsoft.SPOT;
using System.Threading;

namespace Managed_RLP_Example
{
    public class Program
    {
        public static void Main()
        {
            byte[] elfBuffer = Resources.GetBytes(Resources.BinaryResources.ELFFile); //Make sure to add an ELF file as a resource

            RuntimeLoadableProcedures.NativeEvent += RuntimeLoadableProcedures_NativeEvent;

            var elfImage = new RuntimeLoadableProcedures.ElfImage(elfBuffer);

            var yourFunction = elfImage.FindFunction("YourFunc");

            var byteArray = new byte[] { 25, 5, 0 };
            int anInteger = 5;

            var yourFuncResult = yourFunction.Invoke(anInteger, byteArray, byteArray.Length, true);

            Debug.Print("YourFunc returned " + yourFuncResult.ToString()); //Should be 5
            Debug.Print("The third element of the byte array is " + byteArray[2].ToString()); //Should be 30

            var startTask = elfImage.FindFunction("StartTask");
            startTask.Invoke(5);

            Thread.Sleep(-1);
        }

        private static void RuntimeLoadableProcedures_NativeEvent(object sender, RuntimeLoadableProcedures.NativeEventEventArgs e)
        {
            Debug.Print("We've received " + e.Data.ToString() + " from the native side."); //Should be 5 to 0
        }
    }
}