#define CERB_FAMILY

#include "../RLP.h"

RLP_Task task;

void TaskCallback(void* arg)
{
	unsigned int* count = (unsigned int*)arg;
	
	RLP->PostManagedEvent(*count);
		
	if (*count > 0)
	{		
		*count -= 1;
		
		RLP->Task.ScheduleTimeOffset(&task, 1000000);	
	}
	else
	{
		RLP->Task.Abort(&task);
	}
}

int StartTask(void** args)
{
	RLP->Task.Initialize(&task, TaskCallback, args[0], RLP_FALSE);
	RLP->Task.Schedule(&task);
	
	return 1;
}

void Handler(void* arg)
{

}

int InstallInterrupt(void** args)
{
	if (RLP->Interrupt.Install(18, Handler, (void*)0))
        return 1;
	
    return 0;
}

int AddUInt8(void** args)
{
	return (*((unsigned char*)args[0])) + (*((unsigned char*)args[1]));
}

int AddInt8(void** args)
{
	return (*((char*)args[0])) + (*((char*)args[1]));
}

int AddUInt16(void** args)
{
	return (*((unsigned short*)args[0])) + (*((unsigned short*)args[1]));
}

int AddInt16(void** args)
{
	return (*((short*)args[0])) + (*((short*)args[1]));
}

int AddUInt32(void** args)
{
	return (*((unsigned int*)args[0])) + (*((unsigned int*)args[1]));
}

int AddInt32(void** args)
{
	return (*((int*)args[0])) + (*((int*)args[1]));
}

int AddUInt64(void** args)
{
	return (*((unsigned long long*)args[0])) + (*((unsigned long long*)args[1]));
}

int AddInt64(void** args)
{
	return (*((long long*)args[0])) + (*((long long*)args[1]));
}

int AddFloat32(void** args)
{
	return (*((float*)args[0])) + (*((float*)args[1]));
}

int AddFloat64(void** args)
{
	return (*((double*)args[0])) + (*((double*)args[1]));
}

int AddBool(void** args)
{
	return (*((unsigned char*)args[0])) || (*((unsigned char*)args[1]));
}

int AddUInt8Array(void** args)
{
	unsigned char* array = (unsigned char*)args[0]; array[2] = array[0] + array[1]; return 1;
}

int AddInt8Array(void** args)
{
	char* array = (char*)args[0]; array[2] = array[0] + array[1]; return 1;
}

int AddUInt16Array(void** args)
{
	unsigned short* array = (unsigned short*)args[0]; array[2] = array[0] + array[1]; return 1;
}

int AddInt16Array(void** args)
{
	short* array = (short*)args[0]; array[2] = array[0] + array[1]; return 1;
}

int AddUInt32Array(void** args)
{
	unsigned int* array = (unsigned int*)args[0]; array[2] = array[0] + array[1]; return 1;
}

int AddInt32Array(void** args)
{
	int* array = (int*)args[0]; array[2] = array[0] + array[1]; return 1;
}

int AddUInt64Array(void** args)
{
	unsigned long long* array = (unsigned long long*)args[0]; array[2] = array[0] + array[1]; return 1;
}

int AddInt64Array(void** args)
{
	long long* array = (long long*)args[0]; array[2] = array[0] + array[1]; return 1;
}

int AddFloat32Array(void** args)
{
	float* array = (float*)args[0]; array[2] = array[0] + array[1]; return 1;
}

int AddFloat64Array(void** args)
{
	double* array = (double*)args[0]; array[2] = array[0] + array[1]; return 1;
}

int AddBoolArray(void** args)
{
	unsigned char* array = (unsigned char*)args[0]; array[2] = array[0] || array[1]; array[3] = array[0] && array[1]; return 1;
}
